#!/bin/bash

if [ ! -d "acm" ]; then
    git clone https://gitlab.eclipse.org/eclipse-research-labs/codeco-project/acm.git
fi

kind delete cluster
kind create cluster --config ./acm/config/cluster/kind-config.yaml

# The following steps are about plugins that are required to use tha flannel plugin with KinD

# clone and build plugins that kind needs in order to use our custom cni
mkdir -p plugins/bin
wget https://github.com/containernetworking/plugins/releases/download/v1.6.0/cni-plugins-linux-amd64-v1.6.0.tgz
tar -xf cni-plugins-linux-amd64-v1.6.0.tgz -C ./plugins/bin

# copy necessary plugins into all nodes
docker cp ./plugins/bin/. kind-control-plane:/opt/cni/bin
docker cp ./plugins/bin/. kind-worker:/opt/cni/bin
docker cp ./plugins/bin/. kind-worker2:/opt/cni/bin

# fix by Alex UC3M
docker exec -it kind-control-plane modprobe br_netfilter
docker exec -it kind-worker modprobe br_netfilter
docker exec -it kind-worker2 modprobe br_netfilter

docker exec -it kind-control-plane sysctl -p /etc/sysctl.conf
docker exec -it kind-worker sysctl -p /etc/sysctl.conf
docker exec -it kind-worker2 sysctl -p /etc/sysctl.conf
