DEMO_CAM="./acm/config/samples/codeco_v1alpha1_codecoapp_ver3.yaml"

CAM_ARG=$DEMO_CAM
while [[ "$#" -gt 0 ]]; do
    case "$1" in
        --codeco-app)
            CAM_ARG="$2" # Capture the value after --cam
            echo "The CodecoApp $CAM_ARG will be deployed"
            shift 2      # Move past --cam and its value
            ;;
        --create-cluster)
            ./create-kind-cluster.sh
            shift 1      # Move past --cam and its value
            ;;
        *)
            echo "Unknown argument: $1"
            exit 1
            ;;
    esac
done

# Install acm only if not already installed
if [ ! -d "acm" ]; then
    git clone https://gitlab.eclipse.org/eclipse-research-labs/codeco-project/acm.git
fi

# Build and Deploy ACM, which will install all other CODECO components
cd acm
echo $DOCKERHUB_PASS | docker login -u $DOCKERHUB_USER --password-stdin
make docker-build docker-push IMG=$DOCKERHUB_USER/codecoapp-operator:2.0.0
make deploy IMG=$DOCKERHUB_USER/codecoapp-operator:2.0.0
cd ..

kubectl apply -f $CAM_ARG

# This runs integration tests to verify correct CODECO installation and functionality
sleep 5
./integration-test.sh
