#!/bin/bash

echo " ####### Performing Integration tests #######"

## TEST 0: are application pods Running

echo && echo "====== Checking CodecoApp pods ======"
# Wait for 20 minutes, if Codeco Application Pods are not running, then the test is Failed!
if kubectl wait --for=condition=Ready pod --all -n he-codeco-acm --timeout=20m; then
    echo "CodecoApp pods are Running."
else
    kubectl get pods -A;
    exit 1; # error
fi

echo && echo "====== Checking the rest of Codeco pods ======"
## TEST 1: are all CODECO pods Running
if kubectl wait --for=condition=Ready pod --all --all-namespaces --timeout=10m; then
    echo "All CODECO pods are in a Running state."
else
    kubectl get pods -A;
    #exit 1; # error
    # I comment this out until we resolve nodedeamon and kepler pods that are crashing
fi

echo && echo "====== NetMA test 1: Check communication between l2sm interfaces ======"
./tests/netma-test.sh

echo && echo "====== NetMA test 2: Confirm topology metrics are populated ======"
./tests/netma-test2.sh

echo && echo "====== PDLC test: Confirm nodeRecommendations are provided to SWM ======"
./tests/node-recommendations-test.sh

echo && echo "====== MDM test: confirm portability metric is provided correctly by the mdm-api ======"
./tests/mdm-test.sh

echo && echo "====== Get CodecoApp status ======"
./tests/codeco-app-status-check.sh
