#!/bin/bash

### work-in-progress

## TODO: run the following for ALL running codeco apps

APP_NAME='codecoappinstance3'

numPods=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.numPods")
echo
echo "Application contains ${numPods} services  with the following specifications and metrics:"
echo
kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics"

for i in $(seq 0 $(($numPods-1))); do
  serviceName=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].serviceName")
  podName=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].podName.a")
  nodeName=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].nodeName")
  clusterName=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].clusterName")
  avgServiceCpu=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].avgServiceCpu")
  avgServiceMemory=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].avgServiceMemory")
  #Will Check if the variable is not null

done

nodes=($(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.nodeMetrics[].nodeName"))
n_nodes=${#nodes[@]}

echo
echo "Cluster has $n_nodes nodes with the following metrics"
echo

kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.nodeMetrics"

for i in $(seq 0 $(($n_nodes-1))); do
  nodeName=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].nodeName")
  avgNodeMemory=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].avgNodeMemory")
  avgNodeCpu=$(kubectl get codecoapps.codeco.he-codeco.eu -n he-codeco-acm $APP_NAME -o yaml | yq ".status.appMetrics.serviceMetrics[${i}].avgNodeCpu")
done


