# mdm workaround
kubectl rollout restart deployment k8s-connector-check-connection -n he-codeco-mdm

echo "Port forwarding mdm-api port 8090 to 8090 to run mdm test."
kubectl -n he-codeco-mdm port-forward svc/mdm-api 8090:8090  > /dev/null 2>&1 &
sleep 2

portability_test(){

# portability_mdm=$(curl -s -X 'GET' \
#   'http://localhost:8090/mdm/api/v1/pdlc?cluster=https%3A%2F%2Fkubernetes.default.svc&namespace=he-codeco-mdm&pod=mdm-zookeeper-0' \
#   -H 'accept: text/plain' | yq '.spec.versions[0].schema.openAPIV3Schema.properties.spec.properties.portability.value' )

CURRENT_CONTEXT=$(kubectl config current-context)

portability_mdm=$(curl -s -X 'GET' \
  'http://localhost:8090/mdm/api/v1/pdlc?cluster=kind-kind&namespace=he-codeco-mdm&pod=mdm-zookeeper-0' \
  -H 'accept: text/plain' | yq '.spec.versions[0].schema.openAPIV3Schema.properties.spec.properties.portability.value' )

echo
echo "Portability metric according to the MDM API: $portability_mdm"


restarts=$(kubectl get pod -n he-codeco-mdm mdm-zookeeper-0 -o jsonpath='{.status.containerStatuses[0].restartCount}')
portability=$(awk -v r="$restarts" 'BEGIN {print 1/(r + 1)}')
echo
echo "Portability calculated using '1/(restarts + 1)' formula: $portability"


}

portability_test

# You can change the portability value by restarting the mdm-zookeeper-0 pod (portability depends on number of restarts)  
# mdm-zookeeper-0 takes too much time to become Running again for some reason
# kubectl -n he-codeco-mdm exec -it mdm-zookeeper-0 -- /bin/bash -c 'kill 1'
# kubectl wait --for=condition=Ready pod mdm-zookeeper-0 -n he-codeco-mdm --timeout=5m;
# portability_test

pid=$(ps aux | grep "kubectl -n he-codeco-mdm port-forward svc/mdm-api" | grep -v grep | awk '{print $2}')
echo
echo "Cancelling port forwarding."
kill "$pid"
sleep 2 > /dev/null 2>&1 &
