#!/bin/bash

node_recommendations=($(kubectl get applications.qos-scheduler.siemens.com -n he-codeco-acm   acm-swm-app -o yaml | yq ".spec.workloads[].nodeRecommendations"))

node_names=($(kubectl get nodes -o custom-columns=NAME:.metadata.name --no-headers))


app_workloads=($(kubectl get applications.qos-scheduler.siemens.com -n he-codeco-acm   acm-swm-app -o yaml | yq ".spec.workloads[].basename"))


for i in "${!app_workloads[@]}"; do

  node_recommendations=($(kubectl get applications.qos-scheduler.siemens.com -n he-codeco-acm   acm-swm-app -o yaml | yq ".spec.workloads[${i}].nodeRecommendations"))
  echo ""
  echo "Workload: ${app_workloads[${i}]}, node Recommendations: ${node_recommendations[@]}"

  has_recommendations=0
  for node in "${node_names[@]}"; do
    value=$(kubectl get applications.qos-scheduler.siemens.com -n he-codeco-acm   acm-swm-app -o yaml | yq ".spec.workloads[${i}].nodeRecommendations.$node")
    if [[ "$value" =~ ^-?[0-9]+([.][0-9]+)?$ ]]; then
      has_recommendations=1
      echo "       Node: $node, Value: $value "
    fi

  done

  fail_test=0
  if [[ $has_recommendations -eq 1 ]]; then
    echo "Workload ${app_workloads[${i}]} has valid node recommendations"
  else
    echo "Workload ${app_workloads[${i}]} does not have valid node recommendations"
    fail_test=1
  fi


done

exit $fail_test
